#! /usr/bin/perl -w

use Getopt::Long;

use vars qw($e $n $p);

push(@INC, 'perl');
require 'common.pl';

opts();

@DEP = $source;
$ix = 0;
($p, $n, $b, $e) = path_name($source);
$out = "$b.$extension_obj $b.$extension_dep :\n\t";

while($ix <= $#{@DEP}) {
# print "ix $ix dep $DEP[$ix]\n";
    $cont = readfile($DEP[$ix]);
    @CONT = split /\n/, $cont;
    foreach $l (@CONT) {
        if($l =~ /^\s*#\s*include\s*"([^"]+)"/) {
           $fn = $1;
           $f = find_file(\$fn, \@INCDIR);
           if($f eq '') {
               die "could not find '$f'\n";
           }
           add_if_not_in(\@DEP, $f);
        }
    }
    $ix++;
}

$out .= join("\n\t", @DEP);
writefile($outfile, \$out);


sub opts {
    $abort = 0;
    $Getopt::Long::ignorecase = 0;
    $result = &GetOptions("s=s", \$source,
                          "i=s@", \@INCDIR,
                          "o=s", \$outfile,
                          "objdir=s", \$objdir,
                          "depdir=s", \$depdir,
                          "eo=s", \$extension_obj,
                          "ed=s", \$extension_dep,
                          );

    if(!defined($source)) {
        print "no '-s' defined.\n";
        $abort = 1;
    }
    if(!defined(@INCDIR)) {
        print "no '-i' defined.\n";
        $abort = 1;
    }
    if(!defined($outfile)) {
        print "no '-o' defined.\n";
        $abort = 1;
    }
    if(!defined($objdir)) {
        print "no '-objdir' defined.\n";
        $abort = 1;
    }
    if(!defined($depdir)) {
        print "no '-depdir' defined.\n";
        $abort = 1;
    }
    if(!defined($extension_obj)) {
        print "no '-eo' defined.\n";
        $abort = 1;
    }
    if(!defined($extension_dep)) {
        print "no '-ed' defined.\n";
        $abort = 1;
    }

    die "exiting for given reason.\n" if($abort);

    usage() if($result != 1);
}

sub usage {
    print <<"EOS";
$0 -s sourcefile
-i includedir
-o outfile
-objdir objectfile_directory
-depdir dependencyfile_directory
-eo extension of object files
-ed extension of dependency files
EOS
}
